/* @flow */

export default {
  field: {
    type: String,
    required: true
  },
  validators: {
    type: [String, Array, Object],
    required: true
  },
  group: {
    type: String
  },
  multiple: {
    type: Boolean
  },
  autotouch: {
    type: String,
    default: () => {
      return 'on'
    }
  },
  classes: {
    type: Object,
    default: () => {
      return {}
    }
  }
}

export const DEFAULT_CLASSES: Object = {
  valid: 'valid',
  invalid: 'invalid',
  touched: 'touched',
  untouched: 'untouched',
  pristine: 'pristine',
  dirty: 'dirty',
  modified: 'modified'
}
